(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('powerfield', ['exports', '@angular/core'], factory) :
    (factory((global.powerfield = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AutoSelectDirective = /** @class */ (function () {
        function AutoSelectDirective(el) {
            this.el = el;
        }
        /**
         * @return {?}
         */
        AutoSelectDirective.prototype.onclick = /**
         * @return {?}
         */
            function () {
                this.selectAll();
            };
        /**
         * @private
         * @return {?}
         */
        AutoSelectDirective.prototype.selectAll = /**
         * @private
         * @return {?}
         */
            function () {
                this.el.nativeElement.select();
            };
        AutoSelectDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[powAutoSelect]'
                    },] }
        ];
        /** @nocollapse */
        AutoSelectDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef }
            ];
        };
        AutoSelectDirective.propDecorators = {
            onclick: [{ type: core.HostListener, args: ['click', ['$event.target'],] }]
        };
        return AutoSelectDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AutoWidthDirective = /** @class */ (function () {
        function AutoWidthDirective(el, renderer) {
            this.renderer = renderer;
            // Width (in px) to add to the input's width content
            this.powExtraWidth = 0;
            // Maximal input's width
            this.powMaxWidth = 0;
            // Minimal input's width
            this.powMinWidth = 0;
            this.input = ( /** @type {?} */(el.nativeElement));
        }
        /**
         * @return {?}
         */
        AutoWidthDirective.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
            function () {
                this.buildTwin();
                this.adjustWidth();
            };
        /**
         * @return {?}
         */
        AutoWidthDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                document.body.removeChild(this.twin);
            };
        /**
         * @return {?}
         */
        AutoWidthDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.setMaxWidth();
                this.setMinWidth();
            };
        /**
         * @return {?}
         */
        AutoWidthDirective.prototype.oninput = /**
         * @return {?}
         */
            function () {
                this.adjustWidth();
            };
        /**
         * Build a twin component of the input with the same style.
         */
        /**
         * Build a twin component of the input with the same style.
         * @private
         * @return {?}
         */
        AutoWidthDirective.prototype.buildTwin = /**
         * Build a twin component of the input with the same style.
         * @private
         * @return {?}
         */
            function () {
                if (this.twin) {
                    document.body.removeChild(this.twin);
                }
                /** @type {?} */
                var style = window.getComputedStyle(this.input);
                this.twin = document.createElement('span');
                // default twin style
                this.renderer.setStyle(this.twin, 'position', 'absolute');
                this.renderer.setStyle(this.twin, 'top', '-999px');
                this.renderer.setStyle(this.twin, 'left', '-999px');
                this.renderer.setStyle(this.twin, 'opacity', '0');
                this.renderer.setStyle(this.twin, 'width', 'auto');
                this.renderer.setStyle(this.twin, 'white-space', 'pre');
                // twin style based on this.input
                this.renderer.setStyle(this.twin, 'border', style.border);
                this.renderer.setStyle(this.twin, 'padding', style.padding);
                this.renderer.setStyle(this.twin, 'font-family', style.fontFamily);
                this.renderer.setStyle(this.twin, 'font-feature-settings', style.fontFeatureSettings);
                this.renderer.setStyle(this.twin, 'font-size', style.fontSize);
                this.renderer.setStyle(this.twin, 'font-size-adjust', style.fontSizeAdjust);
                this.renderer.setStyle(this.twin, 'font-stretch', style.fontStretch);
                this.renderer.setStyle(this.twin, 'font-style', style.fontStyle);
                this.renderer.setStyle(this.twin, 'font-variant', style.fontVariant);
                this.renderer.setStyle(this.twin, 'font-weight', style.fontWeight);
                this.renderer.setStyle(this.twin, 'letter-spacing', style.letterSpacing);
                this.renderer.setStyle(this.twin, 'text-transform', style.textTransform);
                document.body.appendChild(this.twin);
            };
        /**
         * Adjusts the width of the input.
         */
        /**
         * Adjusts the width of the input.
         * @private
         * @return {?}
         */
        AutoWidthDirective.prototype.adjustWidth = /**
         * Adjusts the width of the input.
         * @private
         * @return {?}
         */
            function () {
                this.clearTwinChildren();
                /** @type {?} */
                var value = this.getValue();
                this.twin.append(document.createTextNode(value));
                /** @type {?} */
                var newWidth = this.twin.getBoundingClientRect().width;
                if (this.powExtraWidth > 0) {
                    newWidth += this.powExtraWidth;
                }
                this.setWidth(newWidth);
            };
        /**
         * Removes all children of twin element.
         */
        /**
         * Removes all children of twin element.
         * @private
         * @return {?}
         */
        AutoWidthDirective.prototype.clearTwinChildren = /**
         * Removes all children of twin element.
         * @private
         * @return {?}
         */
            function () {
                while (this.twin.firstChild) {
                    this.twin.removeChild(this.twin.firstChild);
                }
            };
        /**
         * Gets the value of the input. If it is empty, gets the value of the input's placeholder.
         * @returns the value of the input or of the input's placeholder.
         */
        /**
         * Gets the value of the input. If it is empty, gets the value of the input's placeholder.
         * @return {?} the value of the input or of the input's placeholder.
         */
        AutoWidthDirective.prototype.getValue = /**
         * Gets the value of the input. If it is empty, gets the value of the input's placeholder.
         * @return {?} the value of the input or of the input's placeholder.
         */
            function () {
                /** @type {?} */
                var value = this.input.value;
                if (!value) {
                    value = this.input.placeholder || '';
                }
                return value;
            };
        /**
         * Sets the max-width of the input based on powMaxWidth.
         */
        /**
         * Sets the max-width of the input based on powMaxWidth.
         * @private
         * @return {?}
         */
        AutoWidthDirective.prototype.setMaxWidth = /**
         * Sets the max-width of the input based on powMaxWidth.
         * @private
         * @return {?}
         */
            function () {
                if (this.powMaxWidth > 0) {
                    this.renderer.setStyle(this.input, 'max-width', this.powMaxWidth + "px");
                }
            };
        /**
         * Sets the min-width of the input based on powMinWidth.
         */
        /**
         * Sets the min-width of the input based on powMinWidth.
         * @private
         * @return {?}
         */
        AutoWidthDirective.prototype.setMinWidth = /**
         * Sets the min-width of the input based on powMinWidth.
         * @private
         * @return {?}
         */
            function () {
                if (this.powMinWidth > 0) {
                    this.renderer.setStyle(this.input, 'min-width', this.powMinWidth + "px");
                }
            };
        /**
         * Sets the width of the input if it changed.
         * @param width the width to set.
         */
        /**
         * Sets the width of the input if it changed.
         * @private
         * @param {?} width the width to set.
         * @return {?}
         */
        AutoWidthDirective.prototype.setWidth = /**
         * Sets the width of the input if it changed.
         * @private
         * @param {?} width the width to set.
         * @return {?}
         */
            function (width) {
                if (width !== this.input.getBoundingClientRect().width) {
                    this.renderer.setStyle(this.input, 'width', width + "px");
                }
            };
        AutoWidthDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[powAutoWidth]'
                    },] }
        ];
        /** @nocollapse */
        AutoWidthDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: core.Renderer2 }
            ];
        };
        AutoWidthDirective.propDecorators = {
            powExtraWidth: [{ type: core.Input }],
            powMaxWidth: [{ type: core.Input }],
            powMinWidth: [{ type: core.Input }],
            oninput: [{ type: core.HostListener, args: ['input', ['$event.target'],] }]
        };
        return AutoWidthDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PowerfieldModule = /** @class */ (function () {
        function PowerfieldModule() {
        }
        PowerfieldModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            AutoSelectDirective,
                            AutoWidthDirective
                        ],
                        imports: [],
                        exports: [
                            AutoSelectDirective,
                            AutoWidthDirective
                        ]
                    },] }
        ];
        return PowerfieldModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AutoSelectDirective = AutoSelectDirective;
    exports.AutoWidthDirective = AutoWidthDirective;
    exports.PowerfieldModule = PowerfieldModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=powerfield.umd.js.map