import { AfterContentChecked, ElementRef, OnDestroy, OnInit, Renderer2 } from '@angular/core';
export declare class AutoWidthDirective implements AfterContentChecked, OnDestroy, OnInit {
    private renderer;
    powExtraWidth: number;
    powMaxWidth: number;
    powMinWidth: number;
    private input;
    private twin;
    constructor(el: ElementRef, renderer: Renderer2);
    ngAfterContentChecked(): void;
    ngOnDestroy(): void;
    ngOnInit(): void;
    oninput(): void;
    /**
     * Build a twin component of the input with the same style.
     */
    private buildTwin;
    /**
     * Adjusts the width of the input.
     */
    private adjustWidth;
    /**
     * Removes all children of twin element.
     */
    private clearTwinChildren;
    /**
     * Gets the value of the input. If it is empty, gets the value of the input's placeholder.
     * @returns the value of the input or of the input's placeholder.
     */
    getValue(): string;
    /**
     * Sets the max-width of the input based on powMaxWidth.
     */
    private setMaxWidth;
    /**
     * Sets the min-width of the input based on powMinWidth.
     */
    private setMinWidth;
    /**
     * Sets the width of the input if it changed.
     * @param width the width to set.
     */
    private setWidth;
}
